<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/
session_start();

if ($_SESSION['username'] != "")
{

//FusionPBX Integration
require_once "../fusionpbx/includes/header.php";

$ip_addr =  shell_exec ("/sbin/ifconfig eth0 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'");
$ip = preg_replace ("/\s*/m", "", $ip_addr);
?>
<h2>PBX Integration</h2>
<p>
In order to configure your PBX with SMG, please use the instructions below.<br />
For more information, you can access the wiki by clicking on the following Links:<br />
		<a href="http://wiki.sangoma.com/SMG-Asterisk" target="_blank">Asterisk & SMG Wiki Page</a><br />
        <a href="http://wiki.sangoma.com/SMG-FreeSWITCH" target="_blank">FreeSWITCH & SMG Wiki Page</a>
</p>


<h3>ASTERISK CONFIGURATION</h3>

<p>In order for Sangoma Media Gateway to speak to an Asterisk based PBX, you would need to follow the instructions below.<br />
<font color="red">NOTE: This is a sample configuration. You can adjust the extensions.conf as you require for your PBX</font></p>
<?php
if ($ip == "")
{
	$ip = "IP ADDRESS";
}
else
{
	?>	
	IP Address of eth0 = <?php echo $ip; ?>
    <?php
}
?>

<h4>Asterisk sip.conf</h4>
<pre>
[general]
register=> <b>sangoma</b>:<b>sangoma</b>@<i><?php echo $ip; ?></i>:5062

[authentication]

[SMG]
context=from-SMG
port=5062
host=<i>IP ADDRESS</i>
type=peer
</pre>


<h4>Asterisk extensions.conf</h4>
<u>Incoming Calls:</u>
<pre>
[from-SMG]
exten => s, 1, goto(_X., 1)
exten => _X.,1, set(span=${SIP_HEADER(X-freetdm-SpanName)})
exten => _X.,n,noop(SMG -> incoming call on span=${span})
exten => _X.,n,answer()
exten => _X.,n,playback(demo-congrats)
exten => _X.,n,hangup()
</pre>

<u>Outgoing Calls:</u>
<pre>
exten => _X.,1, dial(sip/${EXTEN}-g=g1-h=a@smg)    ; dial to SMG trunk group named "g1" and use ascending hunting to find a free channel
</pre>

<br />
<h3>FreeSWITCH CONFIGURATION</h3>

<p>In order for Sangoma Media Gateway to speak to an FreeSWITCH based PBX, you would need to follow the instructions below.<br />
<font color="red">NOTE: This is a sample configuration. You can adjust your dialplan as you require for your PBX</font></p>

<h4>FreeSWITCH SIP Registration</h4>
<p>Within the file &quot;/usr/local/freeswitch/conf/sip_profiles/internal.xml&quot;, add the following within the &lt;gateways&gt; tag:</p>
<pre>
&lt;gateway name=&quot;sangoma&quot;&gt;
    	&lt;param name=&quot;username&quot; value=&quot;sangoma&quot;/&gt;
        &lt;param name=&quot;password&quot; value=&quot;sangoma&quot;/&gt;
        &lt;param name=&quot;realm&quot; value=&quot;&lt;<?php echo $ip; ?>:5062&quot;/&gt;
        &lt;param name=&quot;dialplan&quot; value=&quot;xml&quot;/&gt;
        &lt;param name=&quot;context&quot; value=&quot;from-smg&quot;/&gt;
&lt;/gateway&gt;
</pre>

<h4>FreeSWITCH Dialplan</h4>
<p>Within the file "/usr/local/freeswitch/conf/dialplan/default.xml":
<p>Incoming Calls</p>
<pre> 
&lt;context name=&quot;from-smg&quot;&gt;
	&lt;extension name=&quot;incoming&quot;&gt;
		&lt;condition field=&quot;destination number&quot; expression=&quot;<i>Regular Expression</i>&quot; /&gt;
		&lt;action application=&quot;bridge&quot; data=&quot;sofia/internal/EXTENSION@<i><?php echo $ip; ?></i>:5062&quot; /&gt;
		&lt;/condition&gt;
	&lt;/extension&gt;
&lt;/context&gt;<br />
</pre>

<p>Outgoing Calls</p>
<pre> 
&lt;context name=&quot;from-smg&quot;&gt;
	&lt;extension name=&quot;outgoing&quot;&gt;
		&lt;condition field=&quot;destination number&quot; expression=&quot;<i>Regular Expression</i>&quot; /&gt;
		&lt;action application=&quot;bridge&quot; data=&quot;sofia/external/EXTENSION@<i><?php echo $ip; ?></i>:5062&quot; /&gt;
		&lt;/condition&gt;
	&lt;/extension&gt;
&lt;/context&gt;<br />
</pre>


<?php
//FusionPBX Integration
require_once "../fusionpbx/includes/footer.php";
}
else
{
	header( 'Location:../index.php' ) ;
}
?>